//+------------------------------------------------------------------+
//|                                  AbsoluteStrengthMarket_v1.1.mq4 |
//|                           Copyright  2007, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers   6
#property indicator_color1    Blue
#property indicator_width1    2 
#property indicator_color2    Red
#property indicator_width2    2
#property indicator_color3    LightBlue
#property indicator_width3    2
#property indicator_color4    Orange
#property indicator_width4    2 
#property indicator_color5    Yellow
#property indicator_width5    2 
#property indicator_color6    White
#property indicator_width6    2 
#property indicator_maximum   2
#property indicator_minimum   0
//---- input parameters
extern int       TimeFrame    =  0;
extern int       Mode         =  0; // 0-RSI method; 1-Stoch method; 2-ADX method
extern int       Length       = 10; // Period of evaluation
extern int       Smooth       =  5; // Period of smoothing
extern int       Signal       =  5; // Period of Signal Line
extern int       Price        =  0; // Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int       ModeMA       =  3; // Mode of Moving Average
extern double    IndValue     =  1;
extern int       DisplayText  =  0;
extern color     TextColor    = White;
extern double    TextSize     =  8;
extern double    TextDelta    =  0;
extern int       DisplaySets  =  0;

//---- buffers
double Up[];
double Dn[];
double cBulls[];
double cBears[];
double Choppy[];
double NoTrade[];
double trend[];

int    Len, window_init;
bool   firstTime = true;
string TF, short_name, ob_name;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(7);
   
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexBuffer(0,Up);
   SetIndexArrow(0,167);
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexBuffer(1,Dn);
   SetIndexArrow(1,167);
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexBuffer(2,cBulls);
   SetIndexArrow(2,167);
   
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexBuffer(3,cBears);
   SetIndexArrow(3,167);
   
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexBuffer(4,Choppy);
   SetIndexArrow(4,167);
   
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexBuffer(5,NoTrade);
   SetIndexArrow(5,167);
   
   SetIndexBuffer(6,trend);
//---- name for DataWindow and indicator subwindow label
   switch(TimeFrame)
   {
      case 1      : TF="M1"; break;
      case 5      : TF="M5"; break;
      case 15     : TF="M15"; break;
      case 30     : TF="M30"; break;
      case 60     : TF="H1"; break;
      case 240    : TF="H4"; break;
      case 1440   : TF="D1"; break;
      case 10080  : TF="W1"; break;
      case 43200  : TF="MN1"; break;
      default     : TF="Current";
   }
   if(DisplaySets == 1)  
   short_name="AbsoluteStrengthMarket("+Mode+","+Length+","+Smooth+","+Signal+","+ModeMA+")";
   else
   short_name="AbsoluteStrengthMarket";   
   IndicatorShortName(short_name);
      
   SetIndexLabel(0,"Up");
   SetIndexLabel(1,"Down");
   SetIndexLabel(2,"Bear Market Rally");
   SetIndexLabel(3,"Correction");      
   SetIndexLabel(4,"Choppy");
   SetIndexLabel(5,"Non Trade");  
   
   window_init = WindowFind (short_name);
   
   if(TimeFrame == 0) TimeFrame = Period();
   Len = (Length+Smooth+Signal)*TimeFrame/Period();
//----
   SetIndexDrawBegin(0,Len);
   SetIndexDrawBegin(1,Len);
   SetIndexDrawBegin(2,Len);
   SetIndexDrawBegin(3,Len);
   SetIndexDrawBegin(4,Len);
   SetIndexDrawBegin(5,Len);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjDel(ob_name);
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   datetime TimeArray[];
   int      i,y=0,counted_bars=IndicatorCounted();
   
// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   int limit = Bars-counted_bars+TimeFrame/Period();
   
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;
   
   double Bulls = 
   iCustom(NULL,TimeFrame,"AbsoluteStrength_v1.1",Mode,Length,Smooth,Signal,Price,ModeMA,0,0,0,y); 
   double Bears = 
   iCustom(NULL,TimeFrame,"AbsoluteStrength_v1.1",Mode,Length,Smooth,Signal,Price,ModeMA,0,0,1,y); 
   double SigBulls = 
   iCustom(NULL,TimeFrame,"AbsoluteStrength_v1.1",Mode,Length,Smooth,Signal,Price,ModeMA,0,0,2,y); 
   double SigBears = 
   iCustom(NULL,TimeFrame,"AbsoluteStrength_v1.1",Mode,Length,Smooth,Signal,Price,ModeMA,0,0,3,y); 
   
   trend[i] = 0;
   if (Bulls > SigBulls && Bulls > SigBears && Bears < SigBears ) trend[i] = 1;
   if (Bulls > SigBulls && Bulls < SigBears && Bears < SigBears) trend[i] = 2;
   if (Bears > SigBears && Bears > SigBulls && Bulls < SigBulls ) trend[i] = -1;
   if (Bears > SigBears && Bears < SigBulls && Bulls < SigBulls) trend[i] = -2;
   if (Bears > SigBears && Bulls > SigBulls) trend[i] = 3;
   if (Bears < SigBears && Bulls < SigBulls) trend[i] = 4;   
   
   Up[i] = EMPTY_VALUE;
   Dn[i] = EMPTY_VALUE;
   cBulls[i] = EMPTY_VALUE;
   cBears[i] = EMPTY_VALUE;
   Choppy[i] = EMPTY_VALUE;
   NoTrade[i] = EMPTY_VALUE;
   
   if(trend[i] ==  1) Up[i] = IndValue;
   else
   if(trend[i] == -1) Dn[i] = IndValue;
   else
   if(trend[i] ==  2) cBulls[i] = IndValue;
   else
   if(trend[i] == -2) cBears[i] = IndValue;
   else
   if(trend[i] ==  3) Choppy[i] = IndValue;
   else
   if(trend[i] ==  4) NoTrade[i] = IndValue;
   
   }
   
   if (DisplayText==1 && (firstTime || NewBar()))
   {
   ob_name = short_name+" "+TF+" "+IndValue;
   ObjDel(ob_name);  
   int win = WindowFind(short_name);
   
   //Print(" win=",win);
   bool res = ObjectCreate(ob_name,OBJ_TEXT,win,iTime(NULL,0,0)+(Time[0]-Time[1])*3,IndValue+TextDelta);
   //if(!res) Print(" ObjectCreate Error: ",GetLastError());
   
   ObjectSetText(ob_name,TF,TextSize,"Arial",TextColor);
   }
//----
   
   return(0);
}
//+------------------------------------------------------------------+
bool NewBar()
{
   static datetime dt = 0;
   
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}

void ObjDel(string name)
{
   int _GetLastError;
   int obtotal = ObjectsTotal();
   
   for ( int i = 0; i < obtotal; i ++ )
   {
      if( !ObjectDelete(name) )
      {
      _GetLastError = GetLastError();
      //Print( "ObjectDelete Error #", _GetLastError );
      }
   }
}